/*
 *  MIDIMnp.h
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdlib.h>
#include "SMFdefine.h"

#ifndef __MIDIMnp__
#define __MIDIMnp__

typedef struct notes{
	unsigned char channel;	
	unsigned char pitch;
	unsigned char velocity;
	unsigned char dummy1;
	long StartTime;
	long FinishTime;
}Notes;

#endif

extern int MIDIDataSort(long MidiDataNum, Midis *MidiData[]);
extern int CheckNoteOn(unsigned char status,unsigned char velocity);
extern int CheckNoteOff(unsigned char status,unsigned char velocity);
extern int CouplingNoteData(Midis MidiData[],long MidiDataNum,Notes *NoteData[],long *NoteDataNum);
