/*
 *  SMFInDemo.c
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdio.h>
#include "SMFIn.h"

int SMFInDemo(void);
int SMFInDemo(void){

	Midis		*MidiData;
	Metas	*MetaData;
	long		MidiDataNum;
	long		MetaDataNum;
	short		granulality;
	long		s=0,s1=0;
	FILE		*fp;
	int		format;

/*SMFIn Demonstration*/
	fp=fopen("test1.mid","rb");
        if(fp==NULL){
		printf("File open err!\n");
		return false;
        }
	format = SMFIn(fp,&MidiData,&MetaData,&MidiDataNum,&MetaDataNum,&granulality);
	fclose(fp);
	if(format == -1){
		printf("SMF_In is failed!\n");
		return false;
	}
	if(format == 0)	
		printf("SMF format0\n");
	if(format == 1)	
		printf("SMF format1\n");
	
	printf("MIDI-Data is ...\n");
	for(s=0;s<MidiDataNum;s++){
		if((MidiData[s].status == 0xF0)||(MidiData[s].status == 0xF7)){
			printf("%ld status=%X,exclusiveLength=%ld,timestamp=%ld\n"
				,s,MidiData[s].status,MidiData[s].exclusiveLength,MidiData[s].timestamp);
			printf("ExclusiveData = ");
			for(s1=0;s1<MidiData[s].exclusiveLength;s1++)
				printf("%X ",MidiData[s].exclusiveData[s1]);
			printf("\n");
		}
		else
			printf("%d status=%X,note=%d,velocity=%d,timestamp=%ld\n"
				,s,MidiData[s].status,MidiData[s].note,MidiData[s].velocity,MidiData[s].timestamp);
	}
	printf("\nMeta-Data is ...\n");
	for(s=0;s<MetaDataNum;s++){
		printf("%ld number=%x,length=%ld,timestamp=%ld,MetaData="
                    ,s,MetaData[s].num,MetaData[s].length,MetaData[s].timestamp);
		for(s1=0;s1<MetaData[s].length;s1++)
			printf("%x",MetaData[s].data[s1]);
		printf("\n");
	}
	FinishSMFIn(&MidiData,&MetaData,MidiDataNum,MetaDataNum);

	return true;
}
