/*
 *  SMFOutDemo.c
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdio.h>
#include "SMFdefine.h"
#include "SMFOut.h"
#include "SMFIn.h"
#include "MIDIMnp.h"
#include "MetaMnp.h"

int	SMFOutDemo(void);
int	SMFOutDemo(void){

	Midis	*MidiData;
	Metas	*MetaData;
	long	MidiDataNum;
	long	MetaDataNum;
	short	granulality;
	short	s=0,s1=0;
	FILE	*fp;
	int	format;
	
	fp=fopen("test1.mid","rb");
	format = SMFIn(fp,&MidiData,&MetaData,&MidiDataNum,&MetaDataNum,&granulality);
	fclose(fp);
	printf("Finish SMFIn\n");
	MIDIDataSort(MidiDataNum,&MidiData);
	MetaDataSort(MetaDataNum,&MetaData);
	format = 0;
	
	fp=fopen("out1.mid","wb");
	SMFOut(fp,MidiData,MetaData,MidiDataNum,MetaDataNum,granulality,format);
	printf("Finish SMFout\n");
	fclose(fp);
	
	FinishSMFIn(&MidiData,&MetaData,MidiDataNum,MetaDataNum);

	fp=fopen("out1.mid","rb");
	format = SMFIn(fp,&MidiData,&MetaData,&MidiDataNum,&MetaDataNum,&granulality);
	fclose(fp);
	printf("MIDI-Data is ...\n");
	for(s=0;s<MidiDataNum;s++){
		if((MidiData[s].status == 0xF0)||(MidiData[s].status == 0xF7)){
			printf("%d status=%X,exclusiveLength=%ld,timestamp=%ld\n"
			,s,MidiData[s].status,MidiData[s].exclusiveLength,MidiData[s].timestamp);
			printf("ExclusiveData = ");
			for(s1=0;s1<MidiData[s].exclusiveLength;s1++)
				printf("%X ",MidiData[s].exclusiveData[s1]);
			printf("\n");
		}
		else
			printf("%d status=%X,note=%d,velocity=%d,timestamp=%ld\n"
			,s,MidiData[s].status,MidiData[s].note,MidiData[s].velocity,MidiData[s].timestamp);
	}
	printf("\nMeta-Data is ...\n");
	for(s=0;s<MetaDataNum;s++){
		printf("%d number=%x,length=%ld,timestamp=%ld,MetaData="
		,s,MetaData[s].num,MetaData[s].length,MetaData[s].timestamp);
		for(s1=0;s1<MetaData[s].length;s1++)
			printf("%x",MetaData[s].data[s1]);
		printf("\n");
	}
	FinishSMFIn(&MidiData,&MetaData,MidiDataNum,MetaDataNum);

	return true;
}
