/*
 *  SMFdefine.h
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdio.h>

#ifndef __SMFdefine__
#define __SMFdefine__

#define true 1
#define false 0
#define format0		0	
#define format1 	1
#define formatErr	-1

#define SMFDataErr	2
#define	MemoryErr	3

typedef struct midis{
	unsigned char status;
	unsigned char note;
	unsigned char velocity;
	unsigned char dummy;
	long exclusiveLength;
	char *exclusiveData;
	long timestamp;
}Midis;

typedef struct metas{
	short num;
	short dummy;
	char *data;
	long length;
	long timestamp;
}Metas;

#endif
