/*
 *  TrackDataMnp.h
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include "SMFdefine.h"

#ifndef __TrackDataMnp__
#define __TrackDataMnp__

#define	typeMIDI	0
#define	typeMeta	1
#define RunningStatus	-1

typedef struct mmdatas{
	short	type;
	short	status;
	long	num;
	long	datalength;
	long	timestamp;
}MMDatas;

#endif

int ReadHeaderInf(FILE *fp,short *format,short *TrackNum,short *Granulality);
int ReadTrackData(FILE *fp,char **track_data,unsigned long *track_length);
int CountDataNumber(char track_data[],unsigned long track_length,long *MidiDataNum,long *MetaDataNum);
int TrackDataOut(char track_data[],unsigned long track_length,Midis *MidiData[],Metas *MetaData[],long *MidiDataNum,long *MetaDataNum);
long	ReadVariableData(char track_data[],long *data_counter);
long	ReadTimeData(long time,char track_data[],long *data_counter);

int MMDataSort(long MMDataNum, MMDatas *MMData[]);
int CalcVariableData(long data);
int MixMIDIandMetaData(Midis MidiData[],Metas MetaData[],long MidiDataNum,long MetaDataNum,MMDatas *MMData[],unsigned long *TrackLength);
int MakeTrackData(char *TrackData[],Midis MidiData[],Metas MetaData[],long MidiDataNum,long MetaDataNum,MMDatas MMData[],unsigned long TrackLength);
int ChangeVariableData(long data,char DataString[],short *length);
